/* This notice must remain at all times.

afgraphst.js
Copyright (c) Absolute Futurity, 2007.  All rights reserved.
http://www.absolutefuturity.com 
sales@absolutefuturity.com
Version 1.0.2

READ THIS CAREFULLY!

- Absolute Futurity does NOT allow you modify any of the source code in anyway, shape or form!
- Absolute Futurity does NOT allow duplication of any part of this source code!
- Absolute Futurity does NOT allow the use of any parts (background skins, icons, buttons, code, etc...) in any other gadget or product.
- Absolute Futurity does NOT allow any part of this gadget to be used as base for another development start.
- If you want to use any part or function of this gadget, you will need to contact us from our website for written permission first.

!!! Many extra features are available for this gadget with interaction with our product "Speed Test Pro" http://speedtestpro.net/SpeedTest.exe !!!

This javascript uses wz_jsgraphics.js which is copyright of its author. 

*/

hD="0123456789ABCDEF";

var tp = 13;
var h  = 40;
var w  = 125;
var l  = 28;
var dw = 1;
var fnt = 10;
var fntnm = "Verdana"; 


function l_graph()
{
 var sx = w;
 this.cnt = 0;
 this.automax = true;
 this.data     = new Array();
 this.slegend  = new Array();
 this.lcolor  = new Array();
 this.lname  = new Array();
 for (i=0; i<=glines; i++) {
  this.data[i]    = new Array();
  this.slegend[i] = new Array();
  this.lcolor[i] = gadgetsettingread("ncolor" + (i+1),defcolors[i]);
  this.lname[i] = anodetypesshort[gadgetsettingread("ntype" + (i+1),i)];
  if (this.lcolor[i] == '') this.lcolor[i] = defcolors[i];
 }
 this.max = 0;

 this.maxsettings = function(au,mxv)
  {
   this.automax = au; 
   this.max = mxv; 
  }


 this.add = function(slegend, value, lineindex)
  {
   this.slegend[lineindex].push(slegend);  
   this.data[lineindex].push(parseInt(value,10));

   if((value > this.max) && this.automax) {
      this.max = parseInt(value,10);
   }
   if(this.data[lineindex].length > w-l) {
      tmp = this.slegend[lineindex].shift();
      tmp = this.data[lineindex].shift();
   }
  }

 this.gdraw = function(jgid, title)
  {
   sx=w;
   var uselegend = vlegend;
   if (this.automax) {
    tmphigh = 0;
    var ldivision = 1000;
    for (i=0; i<this.data[0].length; i++){
     for (ii=0; ii<=glines; ii++) {
      if (this.data[ii][i] > tmphigh) tmphigh = this.data[ii][i]
     }
    }

    this.max = tmphigh;

    lpower = 0;
    for(yt=1;yt<6;yt++){
     if (tmphigh > Math.pow(lbase,yt)) lpower = yt;
    }
    if (tmphigh == 0) lpower = 0;
    uselegend = lunitletter[lpower+1] + vlegend;
    if (vlegend.indexOf("S") > -1) uselegend = lunitletter[lpower] + vlegend;
   }


   var jg = new jsGraphics(jgid);

   var rtmax = sx + (dw+Math.round(dw/2))*(this.data[0].length);

   // Draw Title & Legend
   jg.setFont(fntnm, fnt,  Font.BOLD);
   jg.setColor("white");
   jg.drawStringRect(title, l+(mGlobalOffset*0.2), (mGlobalOffset*0.5) + 1, w-(l-mGlobalOffset), "center;filter:DropShadow(Color=#000000, OffX=1, OffY=1, Positive=1);");
   jg.setFont(fntnm, fnt+(1-(mGlobalOffset/25)),  Font.BOLD);
   jg.setColor("black");
   jg.drawStringRectH(uselegend, 1+(mGlobalOffset/2.5), (tp+mGlobalOffset)-1, 15, 45, "center;writing-mode:tb-rl;filter:flipv fliph;");
   jg.setColor("white");
   jg.drawStringRectH(uselegend, 0+(mGlobalOffset/2.5), (tp+mGlobalOffset)-2, 15, 45, "center;writing-mode:tb-rl;filter:flipv fliph;");

   // Draw Grid
   jg.setColor("#c0c0c0");
   var i;
   ltmpmax = this.max / Math.pow(lbase,lpower);
   tmprnd = 1;
   if (ltmpmax<100) tmprnd = 10;
   for(i = 1 ; i <= 5 ; i++)
     {
      if (i>1 && i<5) 
       {
        jg.setColor("#6e6e6e");
        jg.drawLine(l+mGlobalOffset,Math.round((h/4*(i-1))+(tp+mGlobalOffset)),w+mGlobalOffset,Math.round((h/4*(i-1))+(tp+mGlobalOffset)));
       }
      var ff = Math.round((ltmpmax - (ltmpmax / 4 * (i-1)))*tmprnd)/tmprnd;
      jg.setFont(fntnm, fnt,  Font.BOLD);
      jg.setColor("white");
      jg.drawString(ff+"",15+(mGlobalOffset/1.7),Math.round(h/4*(i-1))+((tp+(mGlobalOffset*.88))-4),"filter:DropShadow(Color=#000000, OffX=1, OffY=1, Positive=1);");
     }

   // Draw the line graph
   var color = "#00ff00";
   var oldx;
   var oldy =  new Array();
   for (i=0; i<=glines; i++) {
    oldy[i] = -tp;
   }
   jg.setStroke(1);

   for(i = this.data[0].length-1; i > -1; i--)
      {
       for (ii=0; ii<=glines; ii++) {
        usedata = Math.min(this.max,Math.max(0,Math.round(this.data[ii][i])));
        var ht1 = Math.round(usedata*h/this.max)-tp;
        if (usedata == 0) ht1 = -tp;

        jg.setColor(this.lcolor[ii]);
        jg.drawLine(oldx+mGlobalOffset, (h+mGlobalOffset)-oldy[ii], sx+mGlobalOffset, (h+mGlobalOffset)-ht1);
        oldy[ii] = ht1;
       }
       oldx = sx;
       sx = sx-dw;
      }

   jg.paint();
  }

  this.locpoint =function(x,y) {
   var tindex;
   var ht1;
   var lownum = 1000000;
   var useindex;
   if ((w-x) < this.data[0].length) {
    var rg = new jsGraphics("afcross1");
    tindex=(x-(w-this.data[0].length))-1
    for (ii=0; ii<=glines; ii++) {
     ht1 = h-(Math.round(this.data[ii][tindex]*h/this.max)-(tp+mGlobalOffset));
     if (Math.abs(y - ht1) < lownum){
      lownum = Math.abs(y - ht1);
      useindex = ii;
     }
    }

    ht1 = h-(Math.round(this.data[useindex][tindex]*h/this.max)-(tp));
    if (this.data[useindex][tindex] == 0) ht1 = tp+h;
    rg.setColor(gchcolor);
    rg.drawLine(l, ht1, w, ht1);
    rg.drawLine(x, tp, x, h+tp);
    rg.drawLine((x)-1, ht1-1, x+1, ht1-1);
    rg.drawLine((x)-1, ht1+1, x+1, ht1+1);
    rg.setFont(fntnm, fnt,  Font.BOLD);
    rg.setColor(this.lcolor[useindex]);
    rg.fillRect(4+(mGlobalOffset*1.3),4-mGlobalOffset,4+(mGlobalOffset/12.5),4+(mGlobalOffset/12.5));
    tlegenddisp = vlegend;
    if (this.automax) {
     tlegenddisp = lunitletter[lpower+1] + vlegend;
     if (vlegend.indexOf("S") > -1) tlegenddisp = lunitletter[lpower] + vlegend;
    }
    if (tlegenddisp == "Percent") tlegenddisp = "%";
    tmpcurval = Math.round((this.data[useindex][tindex] / Math.pow(lbase,lpower))*100)/100;
    rg.setColor("white");
    rg.drawStringRect(this.lname[useindex], 1+(mGlobalOffset*1.7), 1-mGlobalOffset, 50, "center;filter:DropShadow(Color=#000000, OffX=1, OffY=1, Positive=1);");
    rg.drawStringRect("<nobr>" + tmpcurval + " " + tlegenddisp + "&nbsp;" + this.slegend[useindex][tindex] + "</nobr>", l, h+(tp+(mGlobalOffset*0.4)), w-l, "center;filter:DropShadow(Color=#000000, OffX=1, OffY=1, Positive=1);");
    rg.paint();
   }
  }

}

function getMouseXY() {
 tempX = event.clientX - (afline1.offsetLeft+1+mGlobalOffset);
 tempY = event.clientY - (afline1.offsetTop+1);
 afcross1.innerHTML ="";
 if (tempX > (l) && tempX <= (w) && tempY > ((tp-3)+mGlobalOffset) && tempY < (h+(tp+mGlobalOffset)) && (vencross))  {
  gr.locpoint(tempX,tempY);
 }
 return true;
}

